-------------------------------------------------------------------------------
-- global variables
-------------------------------------------------------------------------------
-- NORMAL 0
-- SEASON 1
-- SPECIAL 2
-- MONSTER 3
-- ACE 4
-- LIVE 5

-- TEAM_YEAR				0
-- TEAM						1
-- YEAR						2
-- DUAL_TEAM_YEAR			3
-- DUAL_TEAM				4
-- DUAL_YEAR				5
-- CLASSIC					6
-- CLASSIC_TEAM				7
-- TRAIT					8

-- 덱 구성 가능한 레코드 리스트
local traitCodes = {"AD_GG"}
local traitDeckPrefix = "T_"


-- 덱 종류별 보너스 스탯 수치
local deckStats = {}
deckStats[0] = {
	S = {15, 0}, A = {6, 0}, B = {4, 0}, C = {2, 0}
}
deckStats[1] = {
	S = {7, 0}, A = {3, 0}, B = {2, 0}, C = {1, 0}
}
deckStats[2] = {
	S = {8, 0}, A = {3, 0}, B = {2, 0}, C = {1, 0}
}
deckStats[3] = {
	S = {13, 13}
}
deckStats[4] = {
	S = {6, 4}
}
deckStats[5] = {
	S = {7, 5}
}
deckStats[6] = {
--80's 연대는 +7, 그 외는 기본으로 +5를 버프 한다
--80's 는 아래 로컬로 저장된 변수에서 스텟을 가져와 사용한다 
	S = {6, 0}
}
deckStats[7] = {
	S = {9, 0}
}
deckStats[8] = {
	S = {5, 0}
}

--80's 연대는 +7
local classic80sDeckStat = {7, 0}

-- 레코드 정보
local traitInfos = {}

-- 골든글러브
traitInfos["T_AD_GG"] = {
	name = "골든글러브"
	, traitCode = "AD_GG"
}


-- 팀 정보
local teamInfos = {}

-- KIA
teamInfos["kia"] = {
	name = "KIA"
	, mainTeamCode = "kia"
	, seasonTeamCodes = {kia = true}
	, familyTeamCodes = {kia = true, haitai = true}
	, shortTeamCode = "ka"
	, listOrder = 1
}

-- KT
teamInfos["kt"] = {
	name = "kt"
	, mainTeamCode = "kt"
	, seasonTeamCodes = {kt = true}
	, familyTeamCodes = {kt = true}
	, shortTeamCode = "kt"
	, listOrder = 2
}

-- LG
teamInfos["lg"] = {
	name = "LG"
	, mainTeamCode = "lg"
	, seasonTeamCodes = {lg = true}
	, familyTeamCodes = {lg = true, mbc = true}
	, shortTeamCode = "lg"
	, listOrder = 3
}

-- NC
teamInfos["nc"] = {
	name = "NC"
	, mainTeamCode = "nc"
	, seasonTeamCodes = {nc = true}
	, familyTeamCodes = {nc = true}
	, shortTeamCode = "nc"
	, listOrder = 4
}

-- SK
teamInfos["sk"] = {
	name = "SK"
	, mainTeamCode = "sk"
	, seasonTeamCodes = {sk = true}
	, familyTeamCodes = {sk = true}
	, shortTeamCode = "sk"
	, listOrder = 5
}

-- 두산
teamInfos["doosan"] = {
	name = "두산"
	, mainTeamCode = "doosan"
	, seasonTeamCodes = {doosan = true}
	, familyTeamCodes = {doosan = true, ob = true}
	, shortTeamCode = "ds"
	, listOrder = 6
}

-- 롯데
teamInfos["lotte"] = {
	name = "롯데"
	, mainTeamCode = "lotte"
	, seasonTeamCodes = {lotte = true}
	, familyTeamCodes = {lotte = true}
	, shortTeamCode = "lt"
	, listOrder = 7
}

-- 삼성
teamInfos["samsung"] = {
	name = "삼성"
	, mainTeamCode = "samsung"
	, seasonTeamCodes = {samsung = true}
	, familyTeamCodes = {samsung = true}
	, shortTeamCode = "ss"
	, listOrder = 8
}

-- 키움
teamInfos["kiwoom"] = {
	name = "키움"
	, mainTeamCode = "kiwoom"
	, seasonTeamCodes = {kiwoom = true}
	, familyTeamCodes = {kiwoom = true, nexen = true}
	, shortTeamCode = "kw"
	, listOrder = 9
}

-- 한화
teamInfos["hanwha"] = {
	name = "한화"
	, mainTeamCode = "hanwha"
	, seasonTeamCodes = {hanwha = true}
	, familyTeamCodes = {hanwha = true, binggrae = true}
	, shortTeamCode = "hh"
	, listOrder = 10
}

-- MBC
teamInfos["mbc"] = {
	name = "MBC"
	, mainTeamCode = "lg"
	, seasonTeamCodes = {lg = true}
	, familyTeamCodes = {lg = true, mbc = true}
	, shortTeamCode = "mc"
	, listOrder = 11
}

-- OB
teamInfos["ob"] = {
	name = "OB"
	, mainTeamCode = "doosan"
	, seasonTeamCodes = {doosan = true}
	, familyTeamCodes = {doosan = true, ob = true}
	, shortTeamCode = "ob"
	, listOrder = 12
}

-- 넥센
teamInfos["nexen"] = {
	name = "넥센"
	, mainTeamCode = "kiwoom"
	, seasonTeamCodes = {kiwoom = true}
	, familyTeamCodes = {kiwoom = true, nexen = true}
	, shortTeamCode = "nx"
	, listOrder = 13
}

-- 빙그레
teamInfos["binggrae"] = {
	name = "빙그레"
	, mainTeamCode = "hanwha"
	, seasonTeamCodes = {hanwha = true}
	, familyTeamCodes = {hanwha = true, binggrae = true}
	, shortTeamCode = "bg"
	, listOrder = 14
}

-- 삼미
teamInfos["sammi"] = {
	name = "삼미"
	, mainTeamCode = "hyundai"
	, seasonTeamCodes = {kiwoom = true}
	, familyTeamCodes = {hyundai = true, pacific = true, chungbo = true, sammi = true}
	, shortTeamCode = "sm"
	, listOrder = 15
}

-- 쌍방울
teamInfos["sbw"] = {
	name = "쌍방울"
	, mainTeamCode = "sbw"
	, seasonTeamCodes = {sk = true}
	, familyTeamCodes = {sbw = true}
	, shortTeamCode = "sw"
	, listOrder = 16
}

-- 청보
teamInfos["chungbo"] = {
	name = "청보"
	, mainTeamCode = "hyundai"
	, seasonTeamCodes = {kiwoom = true}
	, familyTeamCodes = {hyundai = true, pacific = true, chungbo = true, sammi = true}
	, shortTeamCode = "cb"
	, listOrder = 17
}

-- 태평양
teamInfos["pacific"] = {
	name = "태평양"
	, mainTeamCode = "hyundai"
	, seasonTeamCodes = {kiwoom = true}
	, familyTeamCodes = {hyundai = true, pacific = true, chungbo = true, sammi = true}
	, shortTeamCode = "pa"
	, listOrder = 18
}

-- 현대
teamInfos["hyundai"] = {
	name = "현대"
	, mainTeamCode = "hyundai"
	, seasonTeamCodes = {kiwoom = true}
	, familyTeamCodes = {hyundai = true, pacific = true, chungbo = true, sammi = true}
	, shortTeamCode = "hd"
	, listOrder = 19
}

-- 해태
teamInfos["haitai"] = {
	name = "해태"
	, mainTeamCode = "kia"
	, seasonTeamCodes = {kia = true}
	, familyTeamCodes = {kia = true, haitai = true}
	, shortTeamCode = "ht"
	, listOrder = 20
}

-- 덱 선수 구성 조건
local deckConds = {
	S = 19, A = 10, B = 5, C = 3
}

local shortTeamCodes = {}
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- variable 가공
-------------------------------------------------------------------------------
for teamCode, teamInfo in pairs(teamInfos)
do
	shortTeamCodes[teamInfo.shortTeamCode] = teamCode
end
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- 외부 노출용 함수
-------------------------------------------------------------------------------

-- 현재 로스터에서 사용 가능한 덱 목록 반환
function getAvailableDecks(players, deckParams)
	local currDeck = convertToDeck(deckParams)
		
	-- 중복 검사를 피하기 위한 체크 리스트
	local teamYearChecked = {}
	local teamChecked = {}
	local yearChecked = {}
	local classicChecked = {}
	local classicTeamChecked = {}
	local traitChecked = {}
	
	local decks = {}

	for i, p in ipairs(players)
	do
		-- 시즌, 에이스 선수는 무시
		if p.playerType ~= SEASON and p.playerType ~= LIVE and p.playerType ~= ACE then			
			-- 팀연도덱 체크		
			local key = p.teamCode .. p.year
			if not teamYearChecked[key] then
				teamYearChecked[key] = true

				local playerIds, seasonIds, aceIds, monsterIds = getTeamYearDeckPlayers(players, p.teamCode, p.year)
				addDeckIfAvailable(decks, TEAM_YEAR, p.teamCode, p.year, playerIds, seasonIds, aceIds, monsterIds)
			end
			
			-- 팀덱 체크
			local teamCode = teamInfos[p.teamCode].mainTeamCode
			if not teamChecked[teamCode] then
				teamChecked[teamCode] = true
				
				local playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTeamDeckPlayers(players, teamCode)
				addDeckIfAvailable(decks, TEAM, teamCode, nil, playerIds, seasonIds, aceIds, monsterIds)
			end
			
			-- 연도덱 체크
			if not yearChecked[p.year] then
				yearChecked[p.year] = true
				
				local playerIds, seasonIds, aceIds, monsterIds = getYearDeckPlayers(players, p.year)
				addDeckIfAvailable(decks, YEAR, nil, p.year, playerIds, seasonIds, aceIds, monsterIds)
			end
			
			-- 5.8.0부터 클래식 => 연대팀으로 명칭 변경
			-- 연대덱 체크
			local classicYear = math.floor(p.year / 10) * 10;
			if not classicChecked[classicYear] then
				classicChecked[classicYear] = true
				
				local playerIds, seasonIds, aceIds, monsterIds = getClassicDeckPlayers(players, classicYear)
				addDeckIfAvailable(decks, CLASSIC, nil, 20000 + classicYear, playerIds, seasonIds, aceIds, monsterIds)
			end
			
			-- 연대 팀덱 체크
			local classicTeamKey = teamCode .. classicYear
			if not classicTeamChecked[classicTeamKey] then
				classicTeamChecked[classicTeamKey] = true
				
				local playerIds, seasonIds, aceIds, monsterIds = getClassicTeamDeckPlayers(players, teamCode, classicYear)
				addDeckIfAvailable(decks, CLASSIC_TEAM, teamCode, 20000 + classicYear, playerIds, seasonIds, aceIds, monsterIds)
			end
		end
	end
	
	-- 레코드 덱 체크 (덱 설정 가능한 레코드만 체크) 
	for i, traitCode in ipairs(traitCodes)
	do
		if not traitChecked[traitCode] then
			traitChecked[traitCode] = true
			
			-- 레코드 덱팀코드는 prefix "T_"에 traitCode 연결해서 사용
			local deckTeamCode = traitDeckPrefix .. traitCode;
			
			local playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTraitDeckPlayers(players, traitCode)
			addDeckIfAvailable(decks, TRAIT, deckTeamCode, nil, playerIds, seasonIds, aceIds, monsterIds, jokerIds, liveIds)
		end
	end
	
	-- 팀덱 대표팀 세팅 (패밀리 팀이 있을 경우 선수가 더 많은 팀을 우선시함)
	local teamDecks = filterDecksByType(decks, TEAM)
	processTeamDeck(teamDecks, players)
	-- 듀얼 팀덱 세팅
	addDualDecks(decks, teamDecks)

	-- 팀연도덱 필터
	local teamYearDecks = filterDecksByType(decks, TEAM_YEAR)
	-- 듀얼 팀연도덱 세팅
	addDualTeamYearDecks(decks, teamYearDecks)

	-- 연도덱 필터
	local yearDecks = filterDecksByType(decks, YEAR)
	-- 듀얼 연도덱 세팅
	addDualYearDecks(decks, yearDecks)
	
	-- 연대팀덱 대표팀 세팅
	local classicTeamDecks = filterDecksByType(decks, CLASSIC_TEAM)
	processTeamDeck(classicTeamDecks, players)
	
	-- 최종 반환할 덱 목록 생성
	decks = makeTotalDeckList(decks, currDeck)
	
	-- 스탯, 이름 정보 세팅
	for i, deck in ipairs(decks)
	do
		setInfoToDeck(deck)
	end
	
	-- debug
	--dumpList(decks)
	
	return decks 
end

-- 덱 정보 반환
function getDeckInfo(deckParams)
	local deck = convertToDeck(deckParams)

	setInfoToDeck(deck)	

	return deck
end

-- 덱 조건에 맞는 선수 목록과 버프 스탯을 반환
function getDeckApplicablePlayers(players, deckParams)
	local playerStatMap = {}

	local deck = convertToDeck(deckParams)
	if not deck then
		return playerStatMap
	end
	
	local mainStat, subStat = getStat(deck)
	
	local playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
	
	if deck.type == DUAL_TEAM then
		local mainTeamCode, subTeamCode = splitTeamCode(deck.teamCode)
		local subMonsterIds, subActiveTraitIds
		
		-- 시즌 선수 호환 팀끼리의 듀얼이면 시즌 선수는 소속 팀에만 속하도록 함
		local allowSeasonFamilyTeam = checkAllowSeasonFamilyTeam(mainTeamCode, subTeamCode)
		
		-- 메인 덱 선수 세팅
		playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTeamDeckPlayers(players, mainTeamCode, allowSeasonFamilyTeam)
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, mainStat)
				
		-- 서브 덱 선수 세팅
		playerIds, seasonIds, aceIds, subMonsterIds, subActiveTraitIds = getTeamDeckPlayers(players, subTeamCode, allowSeasonFamilyTeam)
		putAllPlayerStatMap(playerStatMap, playerIds, {}, aceIds, subStat)

		mergeTable(activeTraitIds, subActiveTraitIds)

	elseif deck.type == DUAL_TEAM_YEAR then
		local mainYear, subYear = splitYear(deck.year)
		local subMonsterIds, subActiveTraitIds
		
		-- 시즌, 에이스는 메인에 속하도록
		-- 메인 덱 선수 세팅
		playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTeamYearDeckPlayers(players, deck.teamCode, mainYear)
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, mainStat)
				
		-- 서브 덱 선수 세팅
		playerIds, seasonIds, aceIds, subMonsterIds, subActiveTraitIds = getTeamYearDeckPlayers(players, deck.teamCode, subYear)
		putAllPlayerStatMap(playerStatMap, playerIds, {}, {}, subStat)

		-- 서브 덱도 레코드 보너스를 주기 위해 추가
		mergeTable(activeTraitIds, subActiveTraitIds)

	elseif deck.type == DUAL_YEAR then
		local mainYear, subYear = splitYear(deck.year)
		local subMonsterIds, subActiveTraitIds

		-- 시즌, 에이스는 메인에 속하도록
		-- 메인 덱 선수 세팅
		playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getYearDeckPlayers(players, mainYear)
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, mainStat)
				
		-- 서브 덱 선수 세팅
		playerIds, seasonIds, aceIds, subMonsterIds, subActiveTraitIds = getYearDeckPlayers(players, subYear)
		putAllPlayerStatMap(playerStatMap, playerIds, {}, {}, subStat)

		-- 서브 덱도 레코드 보너스를 주기 위해 추가
		mergeTable(activeTraitIds, subActiveTraitIds)

	else
		-- 팀연도, 팀, 연도, 클래식, 레코드 덱의 경우 해당된 플레이어 목록에서 mainStat만 적용해서 반환
		
		if deck.type == TEAM_YEAR then
			playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTeamYearDeckPlayers(players, deck.teamCode, deck.year)
		elseif deck.type == TEAM then
			playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTeamDeckPlayers(players, deck.teamCode)
		elseif deck.type == YEAR then
			playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getYearDeckPlayers(players, deck.year)
		elseif deck.type == CLASSIC then
			-- 클래식은 2+년대 => 21980형식
			local year = deck.year % 10000
			playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getClassicDeckPlayers(players, year)
		elseif deck.type == CLASSIC_TEAM then
			local year = deck.year % 10000
			playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getClassicTeamDeckPlayers(players, deck.teamCode, year)
		elseif deck.type == TRAIT then
			local traitCode = traitInfos[deck.teamCode].traitCode
			playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTraitDeckPlayers(players, traitCode)
		end
		
		putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, mainStat)
	end
	
	-- 덱이 S 등급일 경우 
	if deck.grade == "S" then
		-- 몬스터 선수는 +1 버프를 더 부여
		for i, p in ipairs(players)
		do
			if p.playerType == MONSTER then
				local v = playerStatMap[p.playerId]
				if v then
					playerStatMap[p.playerId] = v + 1
				end
			end
		end 
		
		-- 레코드 장착한 선수는 +1 버프를 더 부여
		if activeTraitIds ~= nil and #activeTraitIds > 0 then
			for i, playerId in ipairs(activeTraitIds)
			do
				local v = playerStatMap[playerId]
				if v then
					playerStatMap[playerId] = v + 1
				end
			end
		else
			activeTraitIds = {}
		end
	else
		activeTraitIds = {}
	end 
	
	return playerStatMap, activeTraitIds
end

-- 덱 조건 설명 반환
function getDeckCond(players, deckParams)
	local deck = convertToDeck(deckParams)
	
	local teamInfo = teamInfos[deck.teamCode]
	
	local cond = {}
	
	if deck.type == TEAM_YEAR then
		cond.mainTeamCode = deck.teamCode		
		cond.mainDescr = string.format("`%02d%s선수 %d명 이상", deck.year % 100, teamInfos[deck.teamCode].name, deckConds[deck.grade])
		cond.mainPlayerCnt = getTeamYearDeckPlayerCount(players, deck.teamCode, deck.year)
		
	elseif deck.type == TEAM then
		cond.mainTeamCode = deck.teamCode
		cond.mainDescr = getTeamDeckCondStr(deck.teamCode, deckConds[deck.grade])
		cond.mainPlayerCnt = getTeamDeckPlayerCount(players, deck.teamCode, true)
		
	elseif deck.type == YEAR then
		cond.mainTeamCode = "kbo"
		cond.mainDescr = string.format("%d선수 %d명 이상", deck.year, deckConds[deck.grade])
		cond.mainPlayerCnt = getYearDeckPlayerCount(players, deck.year)
		
	elseif deck.type == DUAL_TEAM then
		local mainTeamCode, subTeamCode = splitTeamCode(deck.teamCode)
		
		-- 시즌 선수 호환 팀끼리의 듀얼이면 시즌 선수는 소속 팀에만 속하도록 함
		local allowSeasonFamilyTeam = checkAllowSeasonFamilyTeam(mainTeamCode, subTeamCode)
		
		cond.subTeamCode = subTeamCode
		cond.subDescr = getDualTeamDeckCondStr(subTeamCode, 5, 9)
		cond.subPlayerCnt = getTeamDeckPlayerCount(players, subTeamCode, allowSeasonFamilyTeam, false)
		
		cond.mainTeamCode = mainTeamCode
		cond.mainDescr = getDualTeamDeckCondStr(mainTeamCode, 19 - cond.subPlayerCnt)
		cond.mainPlayerCnt = getTeamDeckPlayerCount(players, mainTeamCode, allowSeasonFamilyTeam, true)
	
	elseif deck.type == DUAL_TEAM_YEAR then
		local mainYear, subYear = splitYear(deck.year)

		-- 호환팀인 경우 연도에 따라 팀코드가 다르므로 해당 팀, 연도에 맞는 팀코드 얻기	
		local mainTeamCode = getTeamCodeForDualTeamYearDeckCondStr(players, deck.teamCode, mainYear)
		local subTeamCode = getTeamCodeForDualTeamYearDeckCondStr(players, deck.teamCode, subYear)

		
		cond.subTeamCode = subTeamCode
		cond.subDescr = getDualTeamYearDeckCondStr(subTeamCode, subYear, 5, 9)
		cond.subPlayerCnt = getTeamYearDeckPlayerCount(players, deck.teamCode, subYear, false)
		
		cond.mainTeamCode = mainTeamCode
		cond.mainDescr = getDualTeamYearDeckCondStr(mainTeamCode, mainYear, 19 - cond.subPlayerCnt)
		-- 시즌 선수는 메인에서 카운트
		cond.mainPlayerCnt = getTeamYearDeckPlayerCount(players, deck.teamCode, mainYear, true)

	elseif deck.type == DUAL_YEAR then
		local mainYear, subYear = splitYear(deck.year)
		
		cond.subTeamCode = "kbo"
		cond.subDescr = getDualYearDeckCondStr(subYear, 5, 9)
		cond.subPlayerCnt = getYearDeckPlayerCount(players, subYear, false)		

		cond.mainTeamCode = "kbo"
		cond.mainDescr = getDualYearDeckCondStr(mainYear, 19 - cond.subPlayerCnt)
		cond.mainPlayerCnt = getYearDeckPlayerCount(players, mainYear, true)
	
	elseif deck.type == CLASSIC then
		local year = deck.year % 10000 
		
		local mainTeamCode, subTeamCode = getTeamCodes(deck)
		
		cond.mainTeamCode = mainTeamCode
		cond.mainDescr = string.format("`%02d년대 선수 %d명 이상", year % 100, deckConds[deck.grade])
		cond.mainPlayerCnt = getClassicDeckPlayerCount(players, year)
		
	elseif deck.type == CLASSIC_TEAM then
		local year = deck.year % 10000 
		
		cond.mainTeamCode = deck.teamCode
		cond.mainDescr = string.format("`%02d년대 %s선수 %d명 이상", year % 100, teamInfos[deck.teamCode].name, deckConds[deck.grade])
		cond.mainPlayerCnt = getClassicTeamDeckPlayerCount(players, deck.teamCode, year)
		
	elseif deck.type == TRAIT then
		cond.mainTeamCode = deck.teamCode
		cond.mainDescr = getTraitDeckCondStr(deck.teamCode, deckConds[deck.grade])
		cond.mainPlayerCnt = getTraitDeckPlayerCount(players, deck.teamCode)
	end
	

	return cond
end
-------------------------------------------------------------------------------

-- 현재 덱 정보 생성
function convertToDeck(deckParams)
	local teamCode = deckParams.teamCode
	local year = deckParams.year
	local grade = deckParams.grade
	
	local type = nil
	
	if teamCode and year then
		-- 연대 팀덱 (2+연대 => ex.'00의 경우 22000)
	   	-- 듀얼 팀연도덱 (1+연도+연도 => ex. 94,14인 경우 19414)
		if year >= 20000 then
   			type = CLASSIC_TEAM
   		elseif year >= 10000 then
   			type = DUAL_TEAM_YEAR
     	else
			type = TEAM_YEAR
	   	end
	elseif teamCode then
		-- prefix "T_"가 있을 경우엔 레코드 팀덱
		local traitIndex = string.find(teamCode, traitDeckPrefix)
		if traitIndex then
			type = TRAIT
		else
			-- + 기호가 있을 경우엔 듀얼 팀덱
			local index = string.find(teamCode, "+")
			if index then
				type = DUAL_TEAM
			else
				type = TEAM
			end	
		end	
	elseif year then
		-- 클래식덱 (2+연대 => ex. 80년대인 경우 21980)
    	-- 듀얼 연도덱 (1+연도+연도 => ex. 94,14인 경우 19414)
    	if year >= 20000 then
    		type = CLASSIC
		elseif year >= 10000 then
      		type = DUAL_YEAR
		else
			type = YEAR
  		end
	end
	
	if not type then
		return nil
	end
	
	return {type = type, teamCode = teamCode, year = year, grade = grade, available = true}
end

-- 적용가능한 덱이 있을 경우 리스트에 추가
function addDeckIfAvailable(decks, type, teamCode, year, playerIds, seasonIds, aceIds, monsterIds)
	local deck = makeDeck(type, teamCode, year, playerIds, seasonIds, aceIds, monsterIds)
	
	if deck then
		table.insert(decks, deck)
	end
end

-- 적용가능한 가장 상위 덱 생성
function makeDeck(type, teamCode, year, playerIds, seasonIds, aceIds, monsterIds)
	local total = #playerIds + #seasonIds + #aceIds
	
	-- 해당 조건의 선수가 2명 미만이면 해당 조건에 맞는 덱은 없음
	if total < 2 then
		return nil
	end

	local deck = {
		type = type
		, teamCode = teamCode
		, year = year
		, total = total
		, playerCnt = #playerIds
		, seasonCnt = #seasonIds
		, aceCnt = #aceIds
		, monsterCnt = #monsterIds
	}
	
	-- 클래식
	if type == CLASSIC or type == CLASSIC_TEAM or type == TRAIT then
		-- 11명 미만인 경우 노출하지 않음
		if total < 11 then
			return nil
		end
		
		deck.grade = "S"
		deck.available = total >= deckConds.S
		
		return deck
	end
	
	if total >= deckConds.S then
		deck.grade = "S"
		deck.available = true
	elseif total >= deckConds.A then
		deck.grade = "A"
		deck.available = true
	elseif total >= deckConds.B then
		deck.grade = "B"
		deck.available = true
	else
		deck.grade = "C"
		deck.available = total >= deckConds.C
	end

	-- 팀연도덱 8몬 제한
	if type == TEAM_YEAR and #monsterIds > 8 then
		deck.available = false
	end	
	
	return deck
end

-- 팀덱 메인 팀 세팅
function processTeamDeck(decks, players)
	for i, deck in ipairs(decks)
	do
		local familyTeamCodes = teamInfos[deck.teamCode].familyTeamCodes
			
		local countMap = {}
			
		for j, p in ipairs(players)
		do
			if familyTeamCodes[p.teamCode] then
				if countMap[p.teamCode] then
					countMap[p.teamCode] = countMap[p.teamCode] + 1
				else
					countMap[p.teamCode] = 1
				end
			end	
		end
		
		deck.teamCode = getMaxTeamCode(countMap, teamInfos[deck.teamCode].mainTeamCode)

	end
end

-- 가장 많은 카운트의 팀 코드 반환
function getMaxTeamCode(countMap, mainTeamCode)
	local maxCnt = 0
	local teamCode = nil
	
	for k, v in pairs(countMap)
	do
		if v > maxCnt then
			maxCnt = v
			teamCode = k
		elseif v == maxCnt and teamCode ~= mainTeamCode then
			-- haitai 5명, kia 5명일 경우 kia를 우선해주기 위해서 처리
			teamCode = mainTeamCode
		end
	end
	
	return teamCode
end

-- 덱 타입에 따라 필터링된 결과 반환
function filterDecksByType(decks, type)
	local result = {}
	
	for i, deck in ipairs(decks)
	do
		if deck.type == type then
			table.insert(result, deck)
		end
	end
	
	return result
end

-- 팀덱에서 조합 가능한 듀얼 팀덱을 전체 덱 목록에 추가
function addDualDecks(decks, teamDecks)
	-- 팀덱이 두개 미만일 경우 조합 가능한 듀얼팀덱 없음
	local size = #teamDecks
	if size < 2 then
		return
	end
	
	-- 내림차순 정렬
	sortDecksByTotal(teamDecks)
	 
	for i = 1, size - 1
	do
		for j = i + 1, size
		do
			local d1 = teamDecks[i]
			local d2 = teamDecks[j]
			
			local listOrder1 = teamInfos[d1.teamCode].listOrder;
			local listOrder2 = teamInfos[d2.teamCode].listOrder;
			-- 시즌 선수 리셋으로 total 갯수가 변경될 수 있기 때문에 d1이 언제나 d2 보다 크도록 설정 
			-- d1 d2가 같은 경우는 팀 우선순위에 따라서 swap
			if d1.total < d2.total then
				local tmp = d1
				d1 = d2
				d2 = tmp
			elseif d1.total == d2.total and listOrder1 > listOrder2 then
				local tmp = d1
				d1 = d2
				d2 = tmp
			end
			
			-- 서브덱에 시즌은 리셋
			d2 = removeSeasonPlayer(d2);

			local total = d1.total + d2.total

			if d1.total >= 10 and d2.total >= 5 and total >= 19 then
				-- 두 팀덱의 합이 듀얼팀 조건에 맞을 경우 생성
				table.insert(decks, makeDualDeck(d1, d2))
			elseif d1.total > d2.total and d2.total >= 5 then
				-- 듀얼덱 구성은 안되었지만 UI에 노출하는 조건이 만족할 경우 생성
				table.insert(decks, makeDualDeck(d1, d2))
			end
			
		end
	end
	
end

-- 팀연도덱에서 팀코드가 같은 덱 필터링
function filterTeamYearDecksByTeamCode(decks, familyTeamCodes)

	local tmpDecks = {}	
	for i, deck in pairs(decks)
	do
		if familyTeamCodes[deck.teamCode] then
			table.insert(tmpDecks, deck)
		end
	end

	return tmpDecks;
end

-- 팀연도덱에서 조합 가능한 듀얼 팀연도덱을 전체 덱 목록에 추가
function addDualTeamYearDecks(decks, teamYearDecks)
	-- 팀연도덱이 두개 미만일 경우 조합 가능한 듀얼팀연도덱 없음
	local size = #teamYearDecks
	if size < 2 then
		return
	end
	

	local teamChecked = {}
	for i = 1, size
	do
		local teamCode = teamInfos[teamYearDecks[i].teamCode].mainTeamCode

		if not teamChecked[teamCode] then
			teamChecked[teamCode] = true
	
			local tmpDecks = filterTeamYearDecksByTeamCode(teamYearDecks, teamInfos[teamCode].familyTeamCodes)

			-- 내림차순 정렬
			sortDecksByTotal(tmpDecks)

			local tmpSize = #tmpDecks
	 
			for j = 1, tmpSize - 1
			do
				for k = j + 1, tmpSize
				do
					local d1 = tmpDecks[j]
					local d2 = tmpDecks[k]

					-- 선수가 많은쪽으로 시즌선수 카운트. 같은 경우는 최근 연도에 우선순위
					if d1.total > d2.total then
						d2 = resetSeasonAndAcePlayerCnt(d2)
					else
						local year1 = d1.year
						local year2 = d2.year
						if year1 > year2 then
							d2 = resetSeasonAndAcePlayerCnt(d2)
						else
							d1 = resetSeasonAndAcePlayerCnt(d1)
						end

						-- 선수 수가 같은 경우 최근 연도 우선순위로 total 갯수 변경에 따른 d1, d2 순서 조정. d1이 언제나 d2 보다 크도록 설정				
						if d1.total < d2.total then
							local tmp = d1
							d1 = d2
							d2 = tmp
						end
					end
			
					local total = d1.total + d2.total
			
					if d1.total >= 10 and d2.total >= 5 and total >= 19 then
						-- 두 팀덱의 합이 듀얼팀 조건에 맞을 경우 생성
						table.insert(decks, makeDualTeamYearDeck(d1, d2))
					elseif d1.total > d2.total and d2.total >= 5 then
						-- 듀얼덱 구성은 안되었지만 UI에 노출하는 조건이 만족할 경우 생성
						table.insert(decks, makeDualTeamYearDeck(d1, d2))
					end
			
				end
			end
		end
	end
end

-- 연도덱에서 조합 가능한 듀얼 연도덱을 전체 덱 목록에 추가
function addDualYearDecks(decks, yearDecks)
	-- 연도덱이 두개 미만일 경우 조합 가능한 듀얼연도덱 없음
	local size = #yearDecks
	if size < 2 then
		return
	end
	
	-- 내림차순 정렬
	sortDecksByTotal(yearDecks)
	 
	for i = 1, size - 1
	do
		for j = i + 1, size
		do
			local d1 = yearDecks[i]
			local d2 = yearDecks[j]

			-- 선수가 많은쪽으로 시즌선수 카운트. 같은 경우는 최근 연도에 우선순위
			if d1.total > d2.total then
				d2 = resetSeasonAndAcePlayerCnt(d2)
			else
				local year1 = d1.year
				local year2 = d2.year
				
				if year1 > year2 then
					d2 = resetSeasonAndAcePlayerCnt(d2)
				else
					d1 = resetSeasonAndAcePlayerCnt(d1)
				end

				-- 선수 수가 같은 경우 최근 연도 우선순위로 total 갯수 변경에 따른 d1, d2 순서 조정. d1이 언제나 d2 보다 크도록 설정				
				if d1.total < d2.total then
					local tmp = d1
					d1 = d2
					d2 = tmp
				end
			end

			
			local total = d1.total + d2.total
			
			if d1.total >= 10 and d2.total >= 5 and total >= 19 then
				-- 두 연도덱의 합이 듀얼연도 조건에 맞을 경우 생성
				table.insert(decks, makeDualYearDeck(d1, d2))
			elseif d1.total > d2.total and d2.total >= 5 then
				-- 듀얼덱 구성은 안되었지만 UI에 노출하는 조건이 만족할 경우 생성
				table.insert(decks, makeDualYearDeck(d1, d2))
			end
			
		end
	end
	
end

function makeDualDeck(deck1, deck2)
	local teamCode = teamInfos[deck1.teamCode].shortTeamCode .. "+" .. teamInfos[deck2.teamCode].shortTeamCode			
	local total = deck1.total + deck2.total
	
	return {
		type = DUAL_TEAM
		, teamCode = teamCode
		, year = nil
		, grade = "S"
		, available = (total >= 19)
		, total = total
	}
end

function makeDualTeamYearDeck(deck1, deck2)
	local teamCode = deck1.teamCode
	local mainYear = (deck1.year % 100) * 100
	local subYear = deck2.year % 100
	
	local year = 10000 + mainYear + subYear	
	local total = deck1.total + deck2.total

	-- 듀얼팀연도덱 10몬 제한
	local available = (total >= 19) and (deck1.monsterCnt + deck2.monsterCnt <= 10)
	
	return {
		type = DUAL_TEAM_YEAR
		, teamCode = teamCode
		, year = year
		, grade = "S"
		, available = available
		, total = total
	}
end

function makeDualYearDeck(deck1, deck2)
	local mainYear = (deck1.year % 100) * 100
	local subYear = deck2.year % 100	

	local year = 10000 + mainYear + subYear		
	local total = deck1.total + deck2.total
	
	return {
		type = DUAL_YEAR
		, teamCode = nil
		, year = year
		, grade = "S"
		, available = (total >= 19)
		, total = total
	}
end

-- 두 팀이 같은 시즌 선수를 사용할 경우 호환 허용하지 않음
function checkAllowSeasonFamilyTeam(teamCode1, teamCode2)
	local seasonTeamCodes1 = teamInfos[teamCode1].seasonTeamCodes
	local seasonTeamCodes2 = teamInfos[teamCode2].seasonTeamCodes
	
	-- lua에서는 배열 형태가 아닌 table에서 length 값이 없기 때문에 두개의 set을 각각 for문을 돌려서 동일성을 비교한다
	for k, v in pairs(seasonTeamCodes1)
	do
		if not seasonTeamCodes2[k] then
			return true
		end
	end
	
	for k, v in pairs(seasonTeamCodes2)
	do
		if not seasonTeamCodes1[k] then
			return true
		end
	end
	
	return false
end

-- 해당 덱에서 타입에 맞는 선수 삭제 (playerType = SEASON or LIVE)
function removeSeasonPlayer(deck)

	-- 원본 덱을 복사한 다음 시즌 선수는 0으로 세팅한 후 반환
	local newDeck = cloneDeck(deck)

	local removeCnt = deck.seasonCnt;

	newDeck.playerCnt = deck.playerCnt
	newDeck.seasonCnt = deck.seasonCnt - removeCnt
	newDeck.aceCnt = deck.aceCnt
	newDeck.monsterCnt = deck.monsterCnt

	newDeck.total = newDeck.playerCnt + newDeck.seasonCnt + newDeck.aceCnt

	return newDeck
end

-- 시즌, 에이스 카운트 reset
function resetSeasonAndAcePlayerCnt(deck)	
	-- 원본 덱을 복사한 다음 시즌, 에이스 선수는 0으로 세팅한 후 반환
	local newDeck = cloneDeck(deck)
	newDeck.playerCnt = deck.playerCnt
	newDeck.seasonCnt = 0
	newDeck.aceCnt = 0
	newDeck.monsterCnt = deck.monsterCnt
	newDeck.total = newDeck.playerCnt + newDeck.seasonCnt + newDeck.aceCnt
	
	return newDeck	
end

-- 덱을 내림차순으로 정렬
function sortDecksByTotal(decks)
	local size = #decks
	if size < 2 then
		return
	end
	
	for i = 1, size - 1 
	do
		for j = i + 1, size 
		do
			if decks[i].total < decks[j].total then
				local tmp = decks[i]
				decks[i] = decks[j]
				decks[j] = tmp
			end
		end
	end	
end

-- 팀연도덱에 맞는 선수 목록 반환
function getTeamYearDeckPlayers(players, teamCode, year)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	local activeTraitIds = {}

	local teamInfo = teamInfos[teamCode]
	
	for i, p in ipairs(players)
	do		
		if p.playerType == SEASON then
			-- 시즌 선수일 경우 조건없이 추가
				table.insert(seasonIds, p.playerId)
		elseif p.playerType == LIVE then
			-- 7.0.0 라이브 선수일 경우 조건없이 추가
				table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 에이스 선수일 경우 호환팀인지 체크
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(aceIds, p.playerId)
			end 
		else
			-- 나머지 선수 타입은 연도, 팀코드가 모두 맞아야함
			-- 듀얼 팀연도덱을 위해 호환팀인지 체크 (연도도 같이 체크하므로 단일팀연도덱에 영향 없음)
			if teamInfo.familyTeamCodes[p.teamCode] and p.year == year then
				table.insert(playerIds, p.playerId)

				if p.playerType == MONSTER then
					table.insert(monsterIds, p.playerId)
				end
				
				-- 레코드 장착한 선수
				if p.hasActiveTrait == 1 then
					table.insert(activeTraitIds, p.playerId)
				end
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
end

function getTeamYearDeckPlayerCount(players, teamCode, year, includeSeasonAndAcePlayer)
	if includeSeasonAndAcePlayer == nil then
		includeSeasonAndAcePlayer = true
	end

	local playerIds, seasonIds, aceIds = getTeamYearDeckPlayers(players, teamCode, year)

	if includeSeasonAndAcePlayer then
		return #playerIds + #seasonIds + #aceIds
	end

	return #playerIds
end

-- 연도덱에 맞는 선수 목록 반환
function getYearDeckPlayers(players, year)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	local activeTraitIds = {}

	for i, p in ipairs(players)
	do
		if p.playerType == SEASON or p.playerType == LIVE then
			-- 연도덱에서 시즌 선수는 무조건 해당
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 연도덱에서 에이스 선수는 무조건 해당
			table.insert(aceIds, p.playerId)
		else
			-- 연도가 맞을 경우 해당
			if p.year == year then
				table.insert(playerIds, p.playerId)

				if p.playerType == MONSTER then
					table.insert(monsterIds, p.playerId)
				end
				
				-- 레코드 장착한 선수
				if p.hasActiveTrait == 1 then
					table.insert(activeTraitIds, p.playerId)
				end
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
end

function getYearDeckPlayerCount(players, year, includeSeasonAndAcePlayer)
	if includeSeasonAndAcePlayer == nil then
		includeSeasonAndAcePlayer = true
	end

	local playerIds, seasonIds, aceIds = getYearDeckPlayers(players, year)

	if includeSeasonAndAcePlayer then
		return #playerIds + #seasonIds + #aceIds
	end

	return #playerIds
end

-- 연대에 맞는 선수 목록 반환
function getClassicDeckPlayers(players, year)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	local activeTraitIds = {}
	
	local endYear = year + 10
	
	for i, p in ipairs(players)
	do
		if p.playerType == SEASON or p.playerType == LIVE then
			-- 시즌 선수는 무조건 해당
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 에이스 선수는 무조건 해당
			table.insert(aceIds, p.playerId)
		else
			-- 연대가 맞을 경우 해당
			if p.year >= year and p.year < endYear then
				table.insert(playerIds, p.playerId)

				if p.playerType == MONSTER then
					table.insert(monsterIds, p.playerId)
				end
				
				-- 레코드 장착한 선수
				if p.hasActiveTrait == 1 then
					table.insert(activeTraitIds, p.playerId)
				end
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
end

-- 연대, 팀에 맞는 선수 목록 반환
function getClassicTeamDeckPlayers(players, teamCode, year)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	local activeTraitIds = {}
	
	local endYear = year + 10
	
	local teamInfo = teamInfos[teamCode]
	
	for i, p in ipairs(players)
	do
		if p.playerType == SEASON then
			-- 시즌 선수일 경우 조건없이 추가
				table.insert(seasonIds, p.playerId)
		elseif p.playerType == LIVE then
			-- 7.0.0 라이브 선수일 경우 조건없이 추가
				table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 에이스 선수일 경우 호환팀인지 체크
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(aceIds, p.playerId)
			end 
		else
			-- 연대, 팀이 맞을 경우 해당
			if teamInfo.familyTeamCodes[p.teamCode] and p.year >= year and p.year < endYear then
				table.insert(playerIds, p.playerId)
				
				if p.playerType == MONSTER then
					table.insert(monsterIds, p.playerId)
				end
				
				-- 레코드 장착한 선수
				if p.hasActiveTrait == 1 then
					table.insert(activeTraitIds, p.playerId)
				end
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
end

-- 연대덱 선수 카운트 반환 
function getClassicDeckPlayerCount(players, year, includeSeasonAndAcePlayer)
	if includeSeasonAndAcePlayer == nil then
		includeSeasonAndAcePlayer = true
	end

	local playerIds, seasonIds, aceIds = getClassicDeckPlayers(players, year)

	if includeSeasonAndAcePlayer then
		return #playerIds + #seasonIds + #aceIds
	end

	return #playerIds
end

-- 연대팀덱 선수 카운트 반환 
function getClassicTeamDeckPlayerCount(players, teamCode, year, includeSeasonAndAcePlayer)
	if includeSeasonAndAcePlayer == nil then
		includeSeasonAndAcePlayer = true
	end

	local playerIds, seasonIds, aceIds = getClassicTeamDeckPlayers(players, teamCode, year)

	if includeSeasonAndAcePlayer then
		return #playerIds + #seasonIds + #aceIds
	end

	return #playerIds
end

-- 팀덱에 맞는 선수 목록 반환
function getTeamDeckPlayers(players, teamCode, allowSeasonFamilyTeam)
	if allowSeasonFamilyTeam == nil then
		allowSeasonFamilyTeam = true
	end

	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	local activeTraitIds = {}

	local teamInfo = teamInfos[teamCode]
	
	for i, p in ipairs(players)
	do
		if p.playerType == SEASON then
			-- 6.5.0부터 시즌 선수일 경우 조건없이 추가
			-- 시즌 선수만 따로 카운트한 경우도 추가 (듀얼 팀덱에서 사용)
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == LIVE then
			-- 7.0.0 라이브 선수일 경우 조건없이 추가
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 에이스 선수일 경우 호환팀인지 체크
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(aceIds, p.playerId)
			end 
		else
			-- 나머지 선수 타입은 팀코드가 맞아야함
			if teamInfo.familyTeamCodes[p.teamCode] then
				table.insert(playerIds, p.playerId)

				if p.playerType == MONSTER then
					table.insert(monsterIds, p.playerId)
				end

				-- 레코드 장착한 선수
				if p.hasActiveTrait == 1 then
					table.insert(activeTraitIds, p.playerId)
				end
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
end

-- 레코드덱에 맞는 선수 목록 반환
function getTraitDeckPlayers(players, traitCode)
	local playerIds = {}
	local seasonIds = {}
	local aceIds = {}
	local monsterIds = {}
	local activeTraitIds = {}

	local teamInfo = teamInfos[teamCode]
	
	for i, p in ipairs(players)
	do
		if p.playerType == SEASON then
			-- 시즌 선수일 경우 조건없이 추가
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == LIVE then
			-- 라이브 선수일 경우 조건없이 추가
			table.insert(seasonIds, p.playerId)
		elseif p.playerType == ACE then
			-- 에이스 선수일 경우 조건없이 추가
			table.insert(aceIds, p.playerId)
		else
			-- 나머지 선수 타입은 해당 레코드 보유 여부 체크
			
			-- 선수가 보유하고 있는 레코드 리스트
			local playerTraitCodes = splitToList(p.traitCodes);
			
			if playerTraitCodes[traitCode] then
				-- 보유하고 있는 경우 추가
				table.insert(playerIds, p.playerId)
				
				-- 몬스터인 경우 
				if p.playerType == MONSTER then
					table.insert(monsterIds, p.playerId)
				end

				-- 레코드 장착한 선수
				if p.hasActiveTrait == 1 then
					table.insert(activeTraitIds, p.playerId)
				end
			end
		end
	end
	
	return playerIds, seasonIds, aceIds, monsterIds, activeTraitIds
end


-- 컴마(,)로 구분한 리스트
function splitToList(str)
	local list = {}
	
	if str ~= nil then
		for s in string.gmatch(str, "([^,]+)") do
	   		list[s] = true
		end
	end
	
	return list;
end

function trim(s)
	return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end

function getTeamDeckPlayerCount(players, teamCode, allowSeasonFamilyTeam)
	local playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTeamDeckPlayers(players, teamCode, allowSeasonFamilyTeam)
	
	return #playerIds + #aceIds + #seasonIds
end

function getTraitDeckPlayerCount(players, teamCode)
	local traitCode = traitInfos[teamCode].traitCode
	
	local playerIds, seasonIds, aceIds, monsterIds, activeTraitIds = getTraitDeckPlayers(players, traitCode)
			
	return #playerIds + #aceIds + #seasonIds
end

-- 덱 이름 반환
function getDeckName(deck)
	if deck.type == TEAM_YEAR then
		return string.format("`%02d%s", deck.year % 100, teamInfos[deck.teamCode].name)
	elseif deck.type == TEAM then
		return teamInfos[deck.teamCode].name .. "올스타"
	elseif deck.type == YEAR then
		return string.format("`%02d올스타", deck.year % 100)
	elseif deck.type == DUAL_TEAM then
		local mainTeamCode, subTeamCode = splitTeamCode(deck.teamCode)
		return teamInfos[mainTeamCode].name .. "·" .. teamInfos[subTeamCode].name
	elseif deck.type == DUAL_TEAM_YEAR then
		local mainYear, subYear = splitYear(deck.year)
		return string.format("`%02d·`%02d %s", mainYear % 100, subYear % 100, teamInfos[deck.teamCode].name)
	elseif deck.type == DUAL_YEAR then
		local mainYear, subYear = splitYear(deck.year)
		return string.format("`%02d·`%02d 올스타", mainYear % 100, subYear % 100)
	elseif deck.type == CLASSIC then
		return string.format("%02d's 올스타", deck.year % 100)
	elseif deck.type == CLASSIC_TEAM then
		return string.format("%02d's %s", deck.year % 100, teamInfos[deck.teamCode].name)
	elseif deck.type == TRAIT then
		return traitInfos[deck.teamCode].name
	end

	return ""

end

-- 듀얼 팀 코드를 각 팀 코드로 분리해서 반환
function splitTeamCode(teamCode)
	local index = string.find(teamCode, "+")
	
	if not index then
		return nil
	end
	
	local mainTeamCode = string.sub(teamCode, 1, index - 1)
	local subTeamCode = string.sub(teamCode, index + 1)
	
	return shortTeamCodes[mainTeamCode], shortTeamCodes[subTeamCode]
end

-- 듀얼 연도를 각 연도로 분리해서 반환
function splitYear(year)
	local mainYear = math.floor(year / 100) % 100
	local subYear = year % 100

	mainYear = makeYear(mainYear);
	subYear = makeYear(subYear);
		
	return mainYear, subYear
end

function makeYear(year)
	if year >= 80 then
		return year + 1900
	end

	return year + 2000
end

-- 조건에 맞는 덱 보너스 스탯 반환
function getStat(deck)
	local deckStat = deckStats[deck.type][deck.grade]
	if not deckStat then
		return 0, 0
	end

	if deck.type == CLASSIC and deck.year == 21980 then
		--연대덱의 경우 80's 연대덱은 +6을, 그외에는 +5를 준다
		deckStat = classic80sDeckStat;
	end
	
	return deckStat[1], deckStat[2]
end

-- 덱 정보 세팅
function setInfoToDeck(deck)
	-- 스탯 정보 세팅
	local mainStat, subStat = getStat(deck)
	deck.mainStat = mainStat
	deck.subStat = subStat
	
	-- 이름 세팅
	local name = getDeckName(deck)
	deck.name = name

	-- 배지를 위한 메인팀/서브팀 세팅	
	local mainTeamCode, subTeamCode = getTeamCodes(deck)
	deck.mainTeamCode = mainTeamCode
	deck.subTeamCode = subTeamCode
end



function getTeamCodes(deck)
	if deck.type == TEAM_YEAR or deck.type == TEAM or deck.type == DUAL_TEAM_YEAR or deck.type == CLASSIC_TEAM or deck.type == TRAIT then
		return deck.teamCode, nil
		
	elseif deck.type == YEAR or deck.type == DUAL_YEAR then
		return "kbo", nil
		
	elseif deck.type == CLASSIC then
		--연대덱의 경우 2010년 이전은 구 KBO로고 사용, 그 이후는 현재 KBO 로고 사용
		if deck.year < 22010 then
			return "kbo2", nil
		else
			return "kbo", nil
		end
	elseif deck.type == DUAL_TEAM then
		return splitTeamCode(deck.teamCode)
	end
	
	return nil, nil
end




-- playerStatMap에 각 선수별 stat값을 넣어준다
function putAllPlayerStatMap(playerStatMap, playerIds, seasonIds, aceIds, stat)
	putPlayerStatMap(playerStatMap, playerIds, stat)
	putPlayerStatMap(playerStatMap, seasonIds, stat)
	putPlayerStatMap(playerStatMap, aceIds, stat)
end

-- player-stat map을 편하게 만들기 위한 util 함수
function putPlayerStatMap(map, playerIds, stat)
	if #playerIds > 0 then
		for i, playerId in ipairs(playerIds)
		do
			map[playerId] = stat
		end
	end
end

-- 패밀리 팀 이름 반환. 인자값으로 들어오는 teamCode가 가장 처음 등장
function getSortedFamilyNames(teamCode)
	local familyNames = {}

	local teamInfo = teamInfos[teamCode]
		
	for k, v in pairs(teamInfo.familyTeamCodes)
	do
		if teamCode ~= k then
			table.insert(familyNames, teamInfos[k].name)
		end
	end
	
	return teamInfo.name, familyNames
end

-- 사용가능한 덱 목록에서 최종 반환되는 덱 목록을 생성해서 반환
function makeTotalDeckList(decks, currDeck)
	local totalDecks = {}
	
	for i, deck in ipairs(decks)
	do
		table.insert(totalDecks, deck)
		
		if deck.available then
			if deck.type == TEAM_YEAR or deck.type == TEAM or deck.type == YEAR then
				if deck.grade == "S" then
					if isSameTypeDeck(deck, currDeck) and (currDeck.grade == "A" or currDeck.grade == "B" or currDeck.grade == "C") then
						table.insert(totalDecks, currDeck)
					end
					 
				elseif deck.grade == "A" then
					local other = cloneDeck(deck)
					other.grade = "S"
					other.available = false
					table.insert(totalDecks, other)
					
					if isSameTypeDeck(deck, currDeck) and (currDeck.grade == "B" or currDeck.grade == "C") then
						table.insert(totalDecks, currDeck)
					end
					
				elseif deck.grade == "B" then
					local other = cloneDeck(deck)
					other.grade = "A"
					other.available = false
					table.insert(totalDecks, other)
					
					if isSameTypeDeck(deck, currDeck) and currDeck.grade == "C" then
						table.insert(totalDecks, currDeck)
					end
					
				else
					local other = cloneDeck(deck)
					other.grade = "B"
					other.available = false
					table.insert(totalDecks, other)
				end
			end
		end

	end
	
	return totalDecks
end

function cloneDeck(deck)
	return {
		type = deck.type
		, teamCode = deck.teamCode
		, year = deck.year
		, grade = deck.grade
		, total = deck.total
		, available = deck.available
	}
end

function isSameTypeDeck(deck1, deck2)
	if not deck2 then
		return false
	end
	
	return deck1.type == deck2.type and deck1.year == deck2.year and deck1.teamCode == deck2.teamCode			
end

function getTeamDeckCondStr(teamCode, playerCnt)
	-- 팀덱 조건 설명
	local teamName, familyNames = getSortedFamilyNames(teamCode)
		
	if #familyNames == 0 then
		return string.format("%s선수 %d명 이상", teamName, playerCnt)
	else
		return string.format("%s(%s)선수 %d명 이상", teamName, concateTeamNames(familyNames), playerCnt)
	end
end

function getTraitDeckCondStr(teamCode, playerCnt)
	-- 레코드명 
	local traitName = traitInfos[teamCode].name
		
	return string.format("%s 선수 %d명 이상", traitName, playerCnt)
end

function concateTeamNames(teamNames)
	return table.concat(teamNames, ",")
end

function getDualTeamDeckCondStr(teamCode, minPlayerCnt, maxPlayerCnt)
	local playerCnt
	if maxPlayerCnt then
		playerCnt = minPlayerCnt .. "~" .. maxPlayerCnt
	else
		playerCnt = tostring(minPlayerCnt)
	end
	
	-- 팀덱 조건 설명
	local teamName, familyNames = getSortedFamilyNames(teamCode)
		
	if #familyNames == 0 then
		return string.format("%s선수 %s명", teamName, playerCnt)
	else
		return string.format("%s(%s)선수 %s명", teamName, concateTeamNames(familyNames), playerCnt)
	end
end

function getDualTeamYearDeckCondStr(teamCode, year, minPlayerCnt, maxPlayerCnt)
	local playerCnt
	if maxPlayerCnt then
		playerCnt = minPlayerCnt .. "~" .. maxPlayerCnt
	else
		playerCnt = tostring(minPlayerCnt)
	end

	return string.format("`%02d%s선수 %s명", year % 100, teamInfos[teamCode].name, playerCnt)
end

function getDualYearDeckCondStr(year, minPlayerCnt, maxPlayerCnt)
	local playerCnt
	if maxPlayerCnt then
		playerCnt = minPlayerCnt .. "~" .. maxPlayerCnt
	else
		playerCnt = tostring(minPlayerCnt)
	end
	
	return string.format("`%02d선수 %s명 이상", year % 100, playerCnt)
	
end

-- 듀얼 팀연도덱의 경우 호환가능한 팀이면 연도에 따라 팀코드가 다르므로 팀,연도에 맞는 선수의 팀코드 반환
function getTeamCodeForDualTeamYearDeckCondStr(players, teamCode, year)
	local teamInfo = teamInfos[teamCode]

	for i, p in ipairs(players)
	do
		-- 시즌, 에이스 선수는 넘어감
		if p.playerType ~= SEASON and p.playerType ~= LIVE and p.playerType ~= ACE then
			-- 연도, 팀코드가 동일한 선수의 팀코드 반환
			if teamInfo.familyTeamCodes[p.teamCode] and p.year == year then
				return p.teamCode
			end
		end
	end
	
	return teamCode
end


-- 리스트 덤프
function dumpList(list)
	for i, v in ipairs(list)
	do
		for j, v1 in pairs(v)
		do
			print(j, v1)
		end

		print()
	end
end

-- array 덤프
function dumpArray(array)
	for i, v in ipairs(array)
	do
		print(i, v)
	end
end

-- object 덤프
function dumpObj(obj)
	for k, v in pairs(obj)
	do
		print(k, v)
	end
	
	print()
end

-- 테이블 병합
function mergeTable(t1, t2)
	for k, v in ipairs(t2) do
      table.insert(t1, v)
   end 

   return t1
end
